<template>
    <v-container class="fill-height" fluid>
        <v-col lg="5" class="mx-auto" md="12" sm="12">
            <v-card outlined class="mx-auto pa-3" :elevation="4">
                <v-card-text>
                    <v-alert v-if="err != ''" dense text type="error">
                        {{err}}
                    </v-alert>
                    <v-alert v-if="ok != ''" dense text type="success">
                        {{success}}
                    </v-alert>
                    <p class="display-1 text--primary">
                        Create Worker for {{subCon.light.name}}
                    </p>

                    <v-form ref='form' v-model="valid">
                        <v-row>
                            <v-text-field label="Worker Name"
                                          name="Worker Name"
                                          :counter="64"
                                          v-model="name"
                                          :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.worker' :''"
                                          :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.worker' : ''"
                                          required
                                          :rules="rules"
                                          type="text"/>
                            <v-spacer/>
                            <v-dialog v-model="imageDialog" persistent max-width="600px">
                                <template #activator="{ on , attrs }">
                                    <v-btn fab v-bind="attrs" v-on="on">
                                        <v-avatar size="small">
                                            <v-icon v-if="image == ''">
                                                $vuetify.icons.camera
                                            </v-icon>
                                            <img v-else :src="image" alt="worker photo"/>
                                        </v-avatar>
                                    </v-btn>
                                </template>
                                <ImageLoader
                                        title="Choose Worker Photo"
                                        :on-select="ChooseImage"
                                />
                            </v-dialog>
                        </v-row>
                        <v-row>
                            <v-text-field label="Tag Name"
                                          name="Tag Name"
                                          :counter="64"
                                          v-model="tag"
                                          :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.tag' :''"
                                          :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.tag' : ''"
                                          required
                                          :rules="rules"
                                          type="text">
                                <template v-slot:append>
                                    <v-dialog v-model="scanTagDialog" persistent max-width="600px">
                                        <template #activator="{ on , attrs }">
                                            <v-btn icon v-bind="attrs" v-on="on">
                                                <v-icon v-bind="attrs" v-on="on">
                                                    $vuetify.icons.camera
                                                </v-icon>
                                            </v-btn>
                                        </template>
                                        <qrcode-stream @decode="onDecode"/>
                                    </v-dialog>
                                </template>
                            </v-text-field>
                        </v-row>
                        <v-row>
                            <v-autocomplete
                                    v-model="trade"
                                    :items="Trades"
                                    chips
                                    clearable
                                    label="Trades"
                                    multiple
                                    :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.trade' :''"
                                    :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.trade' : ''"
                            >
                                <template v-slot:selection="{ attrs, item, select, selected }">
                                    <v-chip
                                            :input-value="selected"
                                            @click="select"
                                            @click:close="Remove(item)"
                                            close
                                            v-bind="attrs"
                                    >
                                        <strong>{{ item }}</strong>
                                    </v-chip>
                                </template>
                            </v-autocomplete>
                        </v-row>
                    </v-form>
                </v-card-text>

                <v-card-actions>
                    <v-btn color="primary" :to="`/sub/${subId}`">
                        Back
                    </v-btn>
                    <v-spacer/>
                    <v-btn color="primary" :disabled="!valid" @click="Create">
                        Create
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-col>
    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Prop} from 'vue-property-decorator';
    import {Mixins} from "vue-mixin-decorator";
    import {Validable} from "../../mixins/Validable";
    import ImageLoader from "../../components/ImageLoader.vue";
    import ColorLoader from "../../components/ColorLoader.vue";
    import {coreApi, trades} from "../../init";
    import {SubContractorResponse} from "../../../../classLibrary/core/subContractorResponse";
    import {Initializable} from "../../mixins/Initializable";
    import {SubContractorLightResponse} from "../../../../classLibrary/core/subContractorLightResponse";
    import {WorkerResponse} from "../../../../classLibrary/core/workerResponse";
    import {TagResponse} from "../../../../classLibrary/core/tagResponse";
    import {QrcodeStream} from 'vue-qrcode-reader'

    interface CreateWorkerMixin extends Validable, Initializable {

    }

    @Component({
        components: {ColorLoader, ImageLoader, QrcodeStream}
    })
    export default class CreateWorker extends Mixins<CreateWorkerMixin>(Validable, Initializable) {


        @Prop() subId!: string;
        subCon: SubContractorResponse = new SubContractorResponse(
            new SubContractorLightResponse("", "", "", "", {}),
            []
        )

        async init() {
            this.subId = this.$route.params.id;
            const r = await coreApi.Get<SubContractorResponse>(`SubContractor/${this.subId}`);
            if (!r.success) await this.$router.push("not found")
            else this.subCon = r.Ok!;
        }

        async mountInit() {

        }

        name: string = '';
        image: string = '';
        trade: string[] = [];
        tag: string = '';
        imageDialog: boolean = false;
        scanTagDialog: boolean = false;
        valid: boolean = true;

        onDecode(e: string) {
            this.tag = e;
            this.scanTagDialog = false;
        }

        required = [
            (v: any) => !!v || 'Required',
        ]

        Remove(item: string) {
            this.trade.splice(this.trade.indexOf(item), 1)
            this.trade = [...this.trade]
        }

        rules = [
            (v: any) => !!v || 'SubContractor Name is required',
            (v: any) => (v && v.length >= 5) || 'SubContractor  must be at least 5 characters long',
            (v: any) => (v && v.length <= 64) || 'SubContractor  cannot exceed 64 characters long',
        ]


        async TagExist(): Promise<boolean> {
            const r = await coreApi.Get(`Tag/${this.tag}`);
            return r.success;
        }


        async Create() {
            const tExist = await this.TagExist();
            if (tExist) {
                this.err = `Tag with mac address ${this.tag} already exists`;
                return;
            }
            if (this.image == '') {
                this.err = "Please upload worker's photo";
                return;
            }

            if (this.valid) {
                const r = await coreApi.Post<WorkerResponse>(`Worker/${this.subId}`, {
                    name: this.name,
                    trade: this.trade,
                    image: this.image,
                    data: {},
                });
                if (!r.success) {
                    this.err = r.error!;
                    return
                }

                const wid = r.Ok!.light.id;
                const r1 = await coreApi.Post<TagResponse>(`Tag`, {
                    mac: this.tag,
                    labels: [],
                });
                if (!r1.success) {
                    this.err = r1.error!;
                    return
                }

                const r2 = await coreApi.Post<TagResponse>(`Tag/${this.tag}/add/${wid}`);
                if (!r2.success) {
                    this.err = r2.error!;
                    return
                }
                this.ok = "Successfully create workers and tags!";
                await this.$router.push(`/sub/${this.subId}`);


            }
        }

        ChooseImage(s: string) {
            this.image = s;
            this.imageDialog = false;
        }

        get Trades(): string[] {
            return trades;
        }
    }
</script>
